; Venus 2.3/ION 1.6 Include fileheader by Guillaume Hoffmann
; for TPASM, it will NOT work with TASM
;
;
; REVISION 5 - 21/08/2003
;
;
; How to use this header :
;
;+----------------------------------+
;| INCLUDE "Vion.inc"		    |
;|	db "Program title",0	    |
;|start				    |
;|	[...]	; program code here |
;|	ret			    |
;+----------------------------------+
;
;
;----> Safe Memory Areas
; saferam1 = 768 bytes (apdram)
; saferam2 = 531 bytes (statram)
; saferam3 = 128 bytes (textmem)
; saferam4 = 66 bytes (ops)
; saferam5 = 10 bytes (imathptrs)

 NOLIST

 IFDEF	TI83

bcall MACRO xxxx
 call xxxx
 ENDM

bcallz MACRO xxxx
 call z,xxxx
 ENDM

bcallnz MACRO xxxx
 call nz,xxxx
 ENDM

bcallc MACRO xxxx
 call c,xxxx
 ENDM

bcallnc MACRO xxxx
 call nc,xxxx
 ENDM

bjp MACRO xxxx
 jp xxxx
 ENDM

vRandom		equ $FE72	;
FastCopy	equ $FE75	; Venus routines


_enoughmem	equ 443Ah

_ldhlind	equ 4000h
_cphlde		equ 4004h
_divhlby10	equ 4008h
_divhlbya	equ 400Ch
_getcsc		equ 4014h
_lcdbusy	equ 4066h
_fpadd		equ 4092h
_fpmult		equ 40AAh
_fpdiv		equ 40C6h
_htimesl	equ 4382h	; hl=h*l (error if overflow)
usermemoff	equ 8565h
progstart	equ 9327h
libstart	equ 0002h
saferam1	equ 8265h
saferam2	equ 858Fh
saferam3	equ 80C9h
saferam4	equ 8039h
_homeup		equ 4775h
_newline	equ 473Dh
_darkline	equ 4AE0h
_indicatorOff	equ 4795h
_indicatorOn	equ 4791h
_cleargbuf	equ 515Bh
_copygbuf	equ 4B9Ch
_clrlcdf	equ 4755h
_cleartextshad	equ 4765h
_clrscr		equ 4759h
_clrscrf	equ 475Dh
_iline		equ 4AE4h
_ipoint		equ 4AE8h
_disphl		equ 4709h
_hltimes9	equ 4146h
_vputmap	equ 477Dh
_vputs		equ 4781h
_vputsn		equ 4785h
_putmap		equ 4701h
_puts		equ 470Dh
_putps		equ 4715h
_putc		equ 4705h
_getkey		equ 4CFEh
_getk		equ 4A18h
_rcly		equ 4EE0h
_rclx		equ 4EE8h
_memfree	equ 441Ah
_chksysvar	equ 442Ah
_findsym	equ 442Eh
_creategdb	equ 4486h
_createprog	equ 448Ah
_createreal	equ 4452h
_createstring	equ 4472h
_delvar		equ 44AAh
_insertmem	equ 4432h
_deletemem	equ 44B2h
op1		equ 8039h
op2		equ 8044h
op3		equ 804Fh
op4		equ 805Ah
op5		equ 8065h
op6		equ 8070h
imathptr1	equ 8094h
imathptr2	equ 8096h
imathptr3	equ 8098h
imathptr4	equ 809Ah
imathptr5	equ 809Ch
progptr		equ 9319h
cmdshad		equ 9157h
plotsscreen	equ 8E29h
symtable	equ $FE6E
currow		equ 800Ch
curcol		equ 800Dh
pencol		equ 8252h
penrow		equ 8253h
curgy		equ 886Dh
curgx		equ 886Eh
_op1toop2	equ 418Eh
_op1toop3	equ 417Eh
_op1toop4	equ 416Eh
_op1toop5	equ 41BEh
_op1toop6	equ 41BAh
_op2toop1	equ 41C2h
_op2toop3	equ 41F6h
_op2toop4	equ 4172h
_op2toop5	equ 41B2h
_op2toop6	equ 41B6h
_op3toop1	equ 41A2h
_op3toop2	equ 417Ah
_op3toop4	equ 416Ah
_op3toop5	equ 41AEh
_op4toop1	equ $419A
_op4toop2	equ $4176
_op4toop3	equ $41FA
_op4toop5	equ $41AA
_op4toop6	equ $4202
_op5toop1	equ $419E
_op5toop2	equ $4182
_op5toop3	equ $41FE
_op5toop4	equ $418A
_op5toop6	equ $4186
_op6toop1	equ $4196
_op6toop2	equ $4192
_op6toop5	equ $41A6
_op1exop2	equ $4306
_op1exop3	equ $42FE
_op1exop4	equ $4302
_op1exop5	equ $42EE
_op1exop6	equ $42F2
_op2exop4	equ $42F6
_op2exop5	equ $42FA
_op2exop6	equ $42E6
_op5exop6	equ $42EA
_op1set0	equ $4286
_op1set1	equ $4232
_op1set2	equ $4242
_op1set3	equ $423A
_op1set4	equ $4236
_op2set0	equ $4282
_op2set1	equ $4252
_op2set2	equ $4246
_op2set3	equ $422E
_op2set4	equ $422A
_op2set5	equ $4222
_op2set8	equ $421E
_op2setA	equ $4226
_op3set0	equ $427E
_op3set1	equ $421A
_op3set2	equ $423E
_op4set0	equ $427A
_op4set1	equ $4216
_op5set0	equ $4276
_pushop1	equ $454A
_pushop3	equ $4542
_popop1		equ $44E6
_popop3		equ $44E2
_setxxop1	equ $4A74
_setxxop2	equ $4A78
_setxxxxop2	equ $4A7C
_dispop1a	equ $51D4
_mov9toop1	equ $4206
_convop1	equ $4EFC
_zeroop1	equ $428E
contrast	equ $8008

FREE_MEM_START  equ $930D
FREE_MEM_END	equ $9311

 ENDIF
 IFDEF	TI83P

bcall MACRO xxxx
 rst 28h
 dw xxxx
 ENDM

bcallz MACRO xxxx
 jr nz,$+5
 rst 28h
 dw xxxx
 ENDM

bcallnz MACRO xxxx
 jr z,$+5
 rst 28h
 dw xxxx
 ENDM

bcallc MACRO xxxx
 jr nc,$+5
 rst 28h
 dw xxxx
 ENDM

bcallnc MACRO xxxx
 jr c,$+5
 rst 28h
 dw xxxx
 ENDM

bjp MACRO xxxx
 bcall xxxx
 ret
 ENDM

_enoughmem	EQU 42FDh

_ldhlind	equ 4009h
_cphlde		equ 400Ch
_divhlby10	equ 400Fh
_divhlbya	equ 4012h
_getcsc		equ 4018h
_lcdbusy	equ 4051h
_fpadd		equ 4072h
_fpmult		equ 4084h
_fpdiv		equ 4099h
_hltimes9	equ 40F9h
_htimesl	equ 4276h
_convop1	equ 4AEFh
_darkline	equ $47DD
_darkpoint	equ $47F2
appBackupScreen	equ $9872	; 768 bytes
tempSwapArea	equ $82A5
usermemoff	equ $89EC
libstart	equ $0004
progstart	equ 9D95h
saferam1	equ 9872h
saferam2	equ 858fh
saferam3	equ 80C9h
saferam4	equ 8039h
_homeup		equ $4558
_newline	equ $452E
_cleargbuf	equ 4BD0h
_indicatorOn	equ 456Dh
_indicatorOff	equ 4570h
_copygbuf	equ 486Ah
_clrlcdf	equ 4540h
_cleartextshad	equ 454Ch
_clrscr		equ 4543h
_clrscrf	equ 4546h
_iline		equ 47E0h
_ipoint		equ 47E3h
_disphl		equ 4507h
_vputmap	equ 455Eh
_vputs		equ 4561h
_vputsn		equ 4564h
_putmap		equ 4501h
_puts		equ 450Ah
_putps		equ 4510h
_putc		equ 4504h
_getkey		equ 4972h
_getk		equ 4744h
_rclx		equ $4AE0
_rcly		equ $4ADA
_memfree	equ $42E5
_chksysvar	equ 42F1h
_findsym	equ 42F4h
;_CREATEGDB	equ 4486h
_createreal	equ $430F
_createstring	equ $4327
_createprog	equ $4339
_createprotprog	equ $4E6D
_delvar		equ 4351h
_insertmem	equ 42F7h
_deletemem	equ 4357h

op1		equ 8478h
op2		equ 8483h
op3		equ 8499h
op4		equ 8499h
op5		equ 84A4h
op6		equ 84AFh
imathptr1	equ 84D3h
imathptr2	equ 84D5h
imathptr3	equ 84D7h
imathptr4	equ 84D9h
imathptr5	equ 84DBh
progptr		equ 9830h
cmdshad		equ 966Eh
plotsscreen	equ 9340h
symtable	equ $FE6E
currow		equ 844Bh
curcol		equ 844Ch
pencol		equ 86D7h
penrow		equ 86D8h
curgy		equ 8D18h
curgx		equ 8D19h
_op1set0	equ $41bf
_op1set1	equ $419b
_op1set2	equ $41a7
_op1set3	equ $41a1
_op1set4	equ $419e
_cpop1op2	equ $4111
_op3toop4	equ $4114
_op1toop4	equ $4117
_op2toop4	equ $411A
_op4toop2	equ $411D
_op3toop2	equ $4120
_op1toop3	equ $4123
_op5toop2	equ $4126
_op5toop6	equ $4129
_op5toop4	equ $412C
_op1toop2	equ $412F
_op6toop2	equ $4132
_op6toop1	equ $4135
_op4toop1	equ $4138
_op5toop1	equ $413B
_op3toop1	equ $413E
_op6toop5	equ $4141
_op4toop5	equ $4144
_op3toop5	equ $4147
_op2toop5	equ $414A
_op2toop6	equ $414D
_op1toop6	equ $4150
_op1toop5	equ $4153
_op2toop1	equ $4156
_op2toop3	equ $416E
_op4toop3	equ $4171
_op5toop3	equ $4174
_op4toop6	equ $4177
_zeroop1	equ $41C5
_zeroop2	equ $41C8
_zeroop3	equ $41CB
_setxxop1	equ $478C
_setxxop2	equ $478F
_setxxxxop2	equ $4792
_dispop1a	equ $4BF7
_mov9toop1	equ $417A
_pushop1	equ $43C9
_popop1		equ $437E
contrast	equ 8447h

FREE_MEM_START	equ $9824
FREE_MEM_END	equ $9828

; (only for the 83+)

;-----> Ion Functions
lVectors	equ cmdshad+80
ionVersion	equ lVectors
ionRandom	equ lVectors+3
ionPutSprite	equ lVectors+6
ionLargeSprite	equ lVectors+9
ionGetPixel	equ lVectors+12
FastCopy	equ lVectors+15
ionDetect	equ lVectors+18
ionDecompress	equ lVectors+21

 ENDIF

; Some equates to help to port

grbuf		equ plotsscreen
graph_mem	equ plotsscreen
gbuf		equ plotsscreen
sram		equ saferam1
apdram		equ saferam1
APD_BUF		equ saferam1
savesscreen	equ saferam1
statram		equ saferam2
statvars	equ saferam2
vat		equ progptr
saferam5	equ imathptr1
TEXT_MEM	equ saferam3

GET_KEY		equ _getcsc
_clrtextshad	equ _cleartextshad
_grbufclr	equ _cleargbuf
_bufclr		equ _cleargbuf
_clrlcdfull	equ _clrlcdf
_clrscrnfull	equ _clrscrf
_bufcopy	equ _copygbuf
_grbufcpy	equ _copygbuf


lcdinstport	equ	$10
lcddataport	equ	$11


trigflags       equ       0           ; IY OFFSET VALUE
trigdeg         equ       2
;
plotflags       equ       2           ; IY OFFSET VALUE
plotloc         equ       1
plotdisp        equ       2
;
grfmodeflags    equ       2           ; IY OFFSET VALUE
grffuncm        equ       4
grfpolarm       equ       5
grfparamm       equ       6
grfrecurm       equ       7
;
graphflags      equ       3           ; IY OFFSET VALUE
graphdraw       equ       0
graphcursor     equ       2
;
grfdbflags      equ       4           ; IY OFFSET VALUE
grfdot          equ       0
grfsimul        equ       1
grfgrid         equ       2
grfpolar        equ       3
grfnocoord      equ       4
grfnoaxis       equ       5
grflabel        equ       6
;
textflags       equ       5           ; IY OFFSET VALUE
textEraseBelow  equ       1
textScrolled    equ       2
textInverse     equ       3
;
onflags         equ       9           ; IY OFFSET VALUE
onRunning       equ       3
onInterrupt     equ       4
;
statflags       equ       9           ; IY OFFSET VALUE
statsvalid      equ       6
;
fmtflags        equ       10          ; IY OFFSET VALUE
fmtExponent     equ       0
fmtEng          equ       1
;
nummode         equ       10          ; IY OFFSET VALUE
FMTREAL         equ       5
FMTRECT         equ       6
FMTPOLAR        equ       7
;
curflags        equ       12          ; IY OFFSET VALUE
curAble         equ       2
curOn           equ       3
curLock         equ       4
;
appflags        equ       13          ; IY OFFSET VALUE
appTextSave     equ       1
appAutoScroll   equ       2
;
PLOTFLAG2       equ       17          ; IY OFFSET VALUE
EXPR_PARAM      equ       3
EXPR_WRITING    equ       4
;
indicflags      equ       18          ; IY OFFSET VALUE
indicRun        equ       0
indicOnly       equ       2
;
shiftflags      equ       18          ; IY OFFSET VALUE
shift2nd        equ       3
shiftAlpha      equ       4
shiftALock      equ       6
;
tblflags        equ       19          ; IY OFFSET VALUE
AutoFill        equ       4
AutoCalc        equ       5
;
sgrflags        equ       20          ; IY OFFSET VALUE
grfSplit        equ       0
VertSplit       equ       1
WRITE_ON_GRAPH  equ       4
textwrite       equ       7
;
asm_flag1       equ       33          ; IY OFFSET VALUE
asm_flag1_0     equ       0
asm_flag1_1     equ       1
asm_flag1_2     equ       2
asm_flag1_3     equ       3
asm_flag1_4     equ       4
asm_flag1_5     equ       5
asm_flag1_6     equ       6
asm_flag1_7     equ       7
;
asm_flag2       equ       34          ; IY OFFSET VALUE
asm_flag2_0     equ       0
asm_flag2_1     equ       1
asm_flag2_2     equ       2
asm_flag2_3     equ       3
asm_flag2_4     equ       4
asm_flag2_5     equ       5
asm_flag2_6     equ       6
asm_flag2_7     equ       7
;
asm_flag3       equ       35          ; IY OFFSET VALUE
asm_flag3_0     equ       0
asm_flag3_1     equ       1
asm_flag3_2     equ       2
asm_flag3_3     equ       3
asm_flag3_4     equ       4
asm_flag3_5     equ       5
asm_flag3_6     equ       6
asm_flag3_7     equ       7



;############################
;##     Getcsc/Getk Keys   ##
;############################

G_NONE   equ  $00
G_DOWN   equ  $01
G_LEFT   equ  $02
G_RIGHT  equ  $03
G_UP     equ  $04
G_ENTER  equ  $09
G_PLUS   equ  $0A
G_MINUS  equ  $0B
G_TIMES  equ  $0C
G_DIV    equ  $0D
G_CARROT equ  $0E
G_CLEAR  equ  $0F
G_NEG    equ  $11
G_3      equ  $12
G_6      equ  $13
G_9      equ  $14
G_PARENR equ  $15
G_TAN    equ  $16
G_VARS   equ  $17
G_PERIOD equ  $19
G_2      equ  $1A
G_5      equ  $1B
G_8      equ  $1C
G_PARENL equ  $1D
G_COS    equ  $1E
G_PRGM   equ  $1F
G_STAT   equ  $20
G_0      equ  $21
G_1      equ  $22
G_4      equ  $23
G_7      equ  $24
G_COMMA  equ  $25
G_SIN    equ  $26
G_MATRIX equ  $27
G_XTO    equ  $28
G_ON     equ  $29
G_STO    equ  $2A
G_LN     equ  $2B
G_LOG    equ  $2C
G_SQR    equ  $2D
G_INVE   equ  $2E
G_MATH   equ  $2F
G_ALPHA  equ  $30
G_GRAPH  equ  $31
G_TRACE  equ  $32
G_ZOOM   equ  $33
G_WINDOW equ  $34
G_YEDIT  equ  $35
G_2ND    equ  $36
G_MODE   equ  $37
G_DEL    equ  $38

K_RIGHT   equ    1 ; RIGHT     RIGHT
K_LEFT    equ    2 ; LEFT      LEFT
K_UP      equ    3 ; UP        UP
K_DOWN    equ    4 ; DOWN      DOWN
K_ENTER   equ    5 ; ENTER     ENTER
K_CLEAR   equ    6 ; CLEAR     CLEAR
K_DEL     equ    7 ; DEL       DEL
K_INS     equ    8 ; DEL       INS
K_RCL     equ    9 ; STO>      RCL
K_ENTRY   equ   10 ; ENTER     ENTRY
K_BOL     equ   11 ; LEFT      BOL
K_EOL     equ   12 ; RIGHT     EOL
K_PRGM    equ   45 ; PRGM      PRGM
K_ZOOM    equ   46 ; ZOOM      ZOOM
K_DRAW    equ   47 ; PRGM      DRAW
K_PLOT    equ   48 ; Yequ         STAT PLOT
K_MATH    equ   49 ; MATH      MATH
K_TEST    equ   50 ; MATH      TEST
K_VARS    equ   52 ; VARS      VARS
K_MEM     equ   53 ; +         MEM
K_MATRIX  equ   54 ; MATRIX    MATRIX
K_STAT    equ   55 ; STAT      STAT
K_YVARS   equ   56 ; VARS      Y-VARS
K_ANGLE   equ   57 ; MATRIX    ANGLE
K_LIST    equ   58 ; STAT      LIST
K_CALC    equ   59 ; TRACE     CALC
K_QUIT    equ   64 ; MODE      QUIT
K_LINK    equ   65 ; X,T,theta LINK
K_GRAPH   equ   69 ; GRAPH     GRAPH
K_MODE    equ   70 ; MODE      MODE
K_WINDOW  equ   73 ; WINDOW    WINDOW
K_YEDIT   equ   74 ; Yequ         Yequ
K_TABLE   equ   75 ; GRAPH     TABLE
K_TBLSET  equ   76 ; WINDOW    TblSet
K_TRACE   equ   93 ; TRACE     TRACE
K_PLUS    equ  129 ; +         +
K_MINUS   equ  130 ; -         -
K_TIMES   equ  131 ; *         *
K_DIV     equ  132 ; /         /
K_POWER   equ  133 ; ^         ^
K_LPAREN  equ  134 ; (         (
K_RPAREN  equ  135 ; )         )
K_LBRACK  equ  136 ; *         [
K_RBRACK  equ  137 ; -         ]
K_STO     equ  139 ; STO>      STO>
K_COMMA   equ  140 ; ,         ,
K_NEG     equ  141 ; (-)       (-)
K_PERIOD  equ  142 ; .         .
K_0       equ  143 ; 0         0
K_1       equ  144 ; 1         1
K_2       equ  145 ; 2         2
K_3       equ  146 ; 3         3
K_4       equ  147 ; 4         4
K_5       equ  148 ; 5         5
K_6       equ  149 ; 6         6
K_7       equ  150 ; 7         7
K_8       equ  151 ; 8         8
K_9       equ  152 ; 9         9
K_EE      equ  153 ; ,         EE
K_SEMI    equ  154 ; 0         ;
K_A       equ  155 ; MATH      A
K_B       equ  156 ; MATRIX    B
K_C       equ  157 ; PRGM      C
K_D       equ  158 ; X^-1      D
K_E       equ  159 ; SIN       E
K_F       equ  160 ; COS       F
K_G       equ  161 ; TAN       G
K_H       equ  162 ; ^         H
K_I       equ  163 ; X^2       I
K_J       equ  164 ; ,         J
K_K       equ  165 ; (         K
K_L       equ  166 ; )         L
K_M       equ  167 ; /         M
K_N       equ  168 ; LOG       N
K_O       equ  169 ; 7         O
K_P       equ  170 ; 8         P
K_Q       equ  171 ; 9         Q
K_R       equ  172 ; *         R
K_S       equ  173 ; LN        S
K_T       equ  174 ; 4         T
K_U       equ  175 ; 5         U
K_V       equ  176 ; 6         V
K_W       equ  177 ; -         W
K_X       equ  178 ; STO>      X
K_Y       equ  179 ; 1         Y
K_Z       equ  180 ; 2         Z
K_XTO     equ  181 ; X,T,theta X,T,theta
K_PI      equ  182 ; ^         Pi
K_INVERSE equ  183 ; X^-1      X^-1
K_SIN     equ  184 ; SIN       SIN
K_ASIN    equ  185 ; SIN       SIN^-1
K_COS     equ  186 ; COS       COS
K_ACOS    equ  187 ; COS       COS^-1
K_TAN     equ  188 ; TAN       TAN
K_ATAN    equ  189 ; TAN       TAN^-1
K_SQR     equ  190 ; X^2       X^2
K_SQRT    equ  191 ; X^2       SQRT
K_LN      equ  192 ; LN        LN
K_EX      equ  193 ; LN        e^X
K_LOG     equ  194 ; LOG       LOG
K_TENP    equ  195 ; LOG       10^X
K_ANS     equ  198 ; (-)       ANS
K_COLON   equ  199 ; .         :
K_QUEST   equ  203 ; (-)       ?
K_QUOTE   equ  204 ; +         "
K_THETA   equ  205 ; 3         THETA
K_LBRACE  equ  237 ; (         {
K_RBRACE  equ  238 ; )         }
K_ABS     equ  244 ; X^-1      ABS
K_L1      equ  245 ; 1         L1
K_L2      equ  246 ; 2         L2
K_L3      equ  247 ; 3         L3
K_L4      equ  248 ; 4         L4
K_L5      equ  249 ; 5         L5
K_L6      equ  250 ; 6         L6
K_Vn1     equ  252 ; 8         Vn-1
K_Un1     equ  253 ; 7         Un-1


 LIST

 IFDEF TI83P
	org	progstart-2
	db	$BB,$6D		; ION-compatible program
	ret
	jr	nc,start
 ENDIF

 IFDEF TI83
	org	9329h
	db	"9_[V?",0	; Send(9prgm0V
	jr      nc,start
 ENDIF
